#ifndef AG_CONTAINER_H
#define AG_CONTAINER_H

template <class Object>
class AgContainerContents {
protected:
  virtual ~AgContainerContents() {};
public:
  virtual int size() const = 0;
  virtual const Object &operator [] (int) const = 0;
};

template <class Object, class Base>
class AgContents : public AgContainerContents<Object> {
  const Base base;
public:
  AgContents(const Base &b) : base(b) {}
  int size() const {return base.kernel()->size();}
  const Object &operator [](int x) const {return base.kernel()->operator [](x);}
};

/*
template <class Object, class Container>
class AgAggregate : public AgAggregateContents<Object>, public Container {
  AgAggregate(const Container &c) : AgAggregateContents<Object>(), Container(c) {}
  int size() const {return Container::size();}
  virtual Object &operator [] (int x) const { return Container::operator [](x);}
};
*/
/*
template <class Object, class ContainerBase>
class AgAggregate
: public AgAggregateContents<Object>,
  public AgCopyControl<ContainerBase>
{
public:
  int size() const {return kernel()->size();}
  Object &operator [] (int x) const {return kernel()->operator[](x);}
  AgAggregate(ContainerBase *c)
  : AgAggregateContents<Object>(), AgCopyControl<ContainerBase>(c)
  {
    // Nothing to do
  }
};
*/

/*
template <class Object>
class AgAggregate {
public:
  virtual ~AgAggregate() {}
  virtual int containerSize() const = 0;
  virtual const Object &containerSubscript(int x) const = 0;
};

template <class Object>
int operator == (const AgAggregate<Object> &x, const AgAggregate<Object> &y) {
  int n = x.containerSize();
  if (y.containerSize() != n) return 0;
  while (n--) if (x.containerSubscript(n) != y.containerSubscript(n)) return 0;
  return 1;
}

template <class Object>
int operator != (const AgAggregate<Object> &x, const AgAggregate<Object> &y) {
  return !(x == y);
}
*/
#endif
